#!/usr/bin/env python

# Fill_Selection_With_Brush Rel 3
# Created by Tin Tran http://bakon.ca/gimplearn/
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Call the Paint Brush tool instead of airbrush so that brush size take affect with away. and added progress bar for friendlier.
# Rel 3: fixed spelling mistake from percentangle to percentage

# Fills selection with active brush


import math
from gimpfu import *
#from array import array
import os, string, sys


def python_tt_fill_selection_with_brush(image, layer, horizontalspacing, verticalspacing) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	#PUT YOUR CODE HERE 
	
	#grab selection bounding box for calculations later.
	selection = pdb.gimp_selection_bounds(image);
	
	x1 = selection[1];
	y1 = selection[2];
	x2 = selection[3];
	y2 = selection[4];
	width = x2 - x1
	height = y2 - y1
	
	context_brush_size = pdb.gimp_context_get_brush_size()
	bwidth = context_brush_size * (horizontalspacing/100.0)
	bheight = context_brush_size * (verticalspacing/100.0)
	gimp.progress_init("Filling Selection with Active Brush...")
	
	for x in range(0,int(width/bwidth)+1):
		gimp.progress_update(x*1.0/(int(width/bwidth)+1))
		for y in range(0,int(height/bheight)+1):
			ix = x1 + (x * bwidth)
			iy = y1 + (y * bheight)
			if pdb.gimp_selection_value(image,ix,iy) > 0:
				#pdb.gimp_airbrush(layer,100,2,(ix,iy))
				pdb.gimp_paintbrush(layer,0,2,(ix,iy),PAINT_CONSTANT,0)
	
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return


register(
	"python_fu_tt_fill_selection_with_brush",                           
	"Fills Selection with Active Brush",
	"Fills Selection with Active Brush...",
	"Tin Tran",
	"Tin Tran",
	"2014",
	"Fill Selection With Brush...",             
	"*",
	[
	(PF_IMAGE, "image", "Input image", None),    #current image
	(PF_DRAWABLE, "layer", "Input layer", None), #current layer	
	(PF_SPINNER, "horizontalspacing", "Horizontal Spacing (percentage):", 100, (1, 500, 1)),
	(PF_SPINNER, "verticalspacing", "Vertical Spacing (percentage):", 100, (1, 500, 1)),
	],
	[],
	python_tt_fill_selection_with_brush,
	menu="<Image>/Select")	                     #Menu path

main()
